"
 COPYRIGHT (c) 1988 by Claus Gittinger / eXept Software AG
 COPYRIGHT (c) 2015-2016 Jan Vrany
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:libtool' }"

"{ NameSpace: Smalltalk }"

CodeViewTheme subclass:#Solarized
	instanceVariableNames:''
	classVariableNames:'Base03 Base02 Base01 Base00 Base0 Base1 Base2 Base3 Yellow Orange
		Red Magenta Violet Blue Cyan Green'
	poolDictionaries:''
	category:'Views-Text-Theme'
!

!Solarized class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1988 by Claus Gittinger / eXept Software AG
 COPYRIGHT (c) 2015-2016 Jan Vrany
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!Solarized class methodsFor:'initialization'!

initialize
    "Invoked at system start or when the class is dynamically loaded."

    "/ please change as required (and remove this comment)

    Base03 := Color rgbValue: 16r002b36.
    Base02 := Color rgbValue: 16r073642.
    Base01 := Color rgbValue: 16r586e75.
    Base00 := Color rgbValue: 16r657b83.
    Base0 := Color rgbValue: 16r839496.
    Base1 := Color rgbValue: 16r93a1a1.
    Base2 := Color rgbValue: 16reee8d5.
    Base3 := Color rgbValue: 16rfdf6e3.
    Yellow :=Color rgbValue: 16rb58900.
    Orange := Color rgbValue: 16rcb4b16.
    Red := Color rgbValue: 16rdc322f.
    Magenta := Color rgbValue: 16rd33682.
    Violet := Color rgbValue: 16r6c71c4.
    Blue := Color rgbValue: 16r268bd2.
    Cyan := Color rgbValue: 16r2aa198.
    Green := Color rgbValue: 16r859900.

    "Modified: / 11-12-2017 / 16:23:59 / jv"
! !

!Solarized methodsFor:'styles'!

badIdentifierEmphasis
    "the emphasis used for illegal identifiers;
     If syntaxColoring is turned on."

    ^ self errorEmphasis

    "Created: / 20-12-2017 / 22:50:27 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

commentColor
    "the color used for comments;
     If syntaxColoring is turned on."

    ^ Base01

    "Created: / 15-12-2017 / 22:55:38 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 16-12-2017 / 20:09:10 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

constantColor
    "the color used for constants;
     If syntaxColoring is turned on."

    ^ Cyan

    "Created: / 15-12-2017 / 22:56:33 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 16-01-2019 / 19:12:24 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

debugSelectorColor
    "the color used for some selected debug
     selectors (such as halt etc.);
     If syntaxColoring is turned on.
     If left nil, the normal selector color is used."

    ^ Red

    "Created: / 16-12-2017 / 21:40:18 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

defaultSyntaxBackground
    "Return a background color for the code editor. If nil is returned,
     a TextView's default background is used instread."

    ^ Base3

    "Created: / 11-12-2017 / 17:39:33 / jv"
    "Modified: / 16-12-2017 / 20:08:44 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

defaultSyntaxColor
    "the color used for anything else;
     If syntaxColoring is turned on."

    ^ Color black

    "Created: / 11-12-2017 / 17:39:45 / jv"
    "Modified: / 16-12-2017 / 21:39:42 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

errorColor
    "the color used for the thisContext pseudoVariable;
     If syntaxColoring is turned on."

    ^ Red

    "Created: / 20-12-2017 / 22:48:06 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

errorEmphasis
    ^ (Array with:#underwave with:(#underlineColor->Red))

    "Created: / 20-12-2017 / 22:51:45 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

globalIdentifierEmphasis
    "the color used for global identifiers;
     If syntaxColoring is turned on."

    ^ #bold

    "Created: / 16-12-2017 / 21:39:04 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

identifierColor
    "the color used for other identifiers;
     If syntaxColoring is turned on."

    ^ Blue

    "
     UserPreferences current at:#identifierColor put:Color green darkened darkened.
     UserPreferences current at:#identifierColor put:Color black.
    "

    "Created: / 16-12-2017 / 21:41:59 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

methodSelectorEmphasis
    "the emphasis used for a methods selector pattern;
     If syntaxColoring is turned on."

    ^ #bold

    "Created: / 16-12-2017 / 21:40:54 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

numberConstantColor
    "the color used for number constants;
     If syntaxColoring is turned on."

    ^  Magenta

    "Created: / 16-12-2017 / 20:10:18 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

selfColor
    "the color used for the self pseudoVariable;
     If syntaxColoring is turned on."

    ^ Green

    "Created: / 16-12-2017 / 20:11:44 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 16-01-2019 / 19:13:53 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

selfEmphasis
    "the emphasis used for the self pseudoVariable;
     If syntaxColoring is turned on."

    ^ #bold

    "Created: / 16-01-2019 / 19:14:26 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

thisContextColor
    "the color used for the thisContext pseudoVariable;
     If syntaxColoring is turned on."

    ^ Green

    "Created: / 15-12-2017 / 22:58:12 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

unimplementedSelectorColor
    "the color used for bad message selectors;
     If syntaxColoring is turned on."

    ^ self selectorColor

    "Created: / 20-12-2017 / 22:48:53 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

unimplementedSelectorEmphasis
    "the emphasis used for bad message selectors;
     If syntaxColoring is turned on."

    ^ self errorEmphasis

    "Created: / 20-12-2017 / 22:49:33 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!Solarized methodsFor:'styles - navigation'!

assignmentHighlightEmphasis
    ^ Array with:(#backgroundColor -> Red lighter)

    "Created: / 15-12-2017 / 22:49:35 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

selectorHighlightEmphasis
    ^ Array with:(#backgroundColor -> Blue lighter)

    "Created: / 15-12-2017 / 22:49:46 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

variableHighlightEmphasis
    ^ Array with:(#backgroundColor -> Yellow lighter)

    "Created: / 15-12-2017 / 22:49:54 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!Solarized class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !


Solarized initialize!
